{{
        Battlez0wned
        by Michael Park

        VGA mods by Ross Higson
        
        Version 1.1

        We, Michael Park and Ross Higson, hereby place this file into the public domain.
                 
}}
{        
        2007-09-19 Proof of concept runs fast enough
        2007-09-20 Stripping down graphics_drv to free up memory
        2007-09-21 0001: tank demo (rotation controlled by gamepad) with radar mockup, crosshairs, background.
        2007-09-21 Now to make it real.
        2007-09-22 Draws tank and obstacles, radar and crosshair work, can drive tanks around.
        2007-09-22 Reclaimed graphics driver assembly language DAT space for display buffer.
                   Rudimentary collision detection, BLOCKED indicator.
        2007-09-23 Bullets. Had to shift world coordinates (<< SHIFT) for finer movement resolution.
                   Decided to make objects flash rather than worry about making explosions.
                   Space is very tight. Shrunk screen size (16x11 tiles, 256x176 pixels).
                   Background mountains.
        2007-09-23/24 Tank drawing and object drawing in separate cogs running in parallel with backdrop drawing.
                   Unfortunately, backdrop gets painted on top of tanks and objects.
                   Changed to tank drawing and backdrop drawing in separate cogs. Backdrop drawing starts
                   as soon as tank heading is determined. Tank drawing occurs concurrently with object drawing
                   in the main cog.
        2007-09-24/25 Scoring, title screen.
        2007-09-25/26 Got HYDRA-Net working!
                   Selectable steering mode.                            
        2007-09-27 Volcano!
        2007-09-29&30 Running at NWCGE in Portland.
        2007-10-03 Minor fixes.
        2007-08-18 First VGA version
        2007-08-20 Second VGA version (minor speed and memory space improvements)
        2007-08-23 Fixed an object rendering problem, more memory optimization
        
                   ToDo: Sound would be nice but there's no room.
                   
                   Should probably: Eliminate explicit "<< SHIFT"; reorder object wireframe coords; use constant();
                   refactor drawing code (and everything else); improve collision/hit detection; smarter mountain drawing.
        
        World coordinates
        - X-axis runs east-west (east is positive)
        - Y-axis runs north-south (north is positive)
        - Z-axis runs up-down (up is positive)
        (Right hand rule)

        Angles are mod 8192
        Heading 0 is east; heading increases counter-clockwise (i.e. 2048 is north)

        Screen coordinates
        - (0,0) is center of screen
        - X-axis: right is positive
        - Y-axis: up is positive 
         
}      

CON

  SOLO = true   ' false for two-Hydra network.

  _clkmode = xtal1 + pll8x
  _xinfreq = 10_000_000 + 0000
  _stack = 65  

  paramcount = 21       


  COLOUR_MODE       = 1                ' 0 = 2 colour mode, 1 = 4 colour mode. Not all resolutions support 4 colours.

  DOUBLE_BUFFER     = TRUE             ' Double buffering is recommended for screens that are redrawn rapidly.
                                       ' (Note that you cannot turn double buffering on or off "on the fly").
                                       ' It is recommended to leave this on.

  RAM_RECYCLE       = TRUE             ' Reclaim the RAM used for cog data once the cogs are loaded. 
'{
'--- 640x480 --------------------------------------------------------------------------------------------------------
  'vga constants:
  mode = COLOUR_MODE << 3 + %000
  '    72Hz       60Hz
  hd = 640        '640
  hf = 24         '16
  hs = 40         '96
  hb = 128        '48
  vd = 480        '480
  vf = 9          '10
  vs = 3          '4
  vb = 28         '33
  px = 31_500_000 '25_000_000
  
  'game constants:
  CLIP_ADJUST = 1
'}

{
'--- 800 x 600 --------------------------------------------------------------------------------------------------------
  'vga constants:
  mode = COLOUR_MODE << 3 + %011
  hd = 800
  hf = 40
  hs = 128
  hb = 88
  vd = 600
  vf = 1
  vs = 4
  vb = 23
  px = $2625A00 '40_000_000
  
  'game constants:
  CLIP_ADJUST = 1
}

{
'--- 1024 x 768 --------------------------------------------------------------------------------------------------------
  'vga constants:
  mode = COLOUR_MODE << 3 + %000
  hd = 1024
  hf = 24
  hs = 136
  hb = 160
  vd = 768
  vf = 3
  vs = 6
  vb = 29
  px = 64_000_000      'reduces jitter - correct value is 65_000_000
   
  'game constants:
  CLIP_ADJUST = 2
}

{
'--- 1152 x 864 --------------------------------------------------------------------------------------------------------
  'vga constants:
  mode = COLOUR_MODE << 3 + %001
  hd = 1152
  hf = 64
  hs = 112
  hb = 256
  vd = 864
  vf = 6
  vs = 5
  vb = 41
  px = 80_000_000

  'game constants:
  CLIP_ADJUST = 2
}

'-----------------------------------------------------------------------------------------------------------------------

  ' screen constants:
  X_TILES           = hd / (32>>COLOUR_MODE) 
  Y_TILES           = vd / 16 

  X_SCREEN          = X_TILES * (32>>COLOUR_MODE)   
  Y_SCREEN          = Y_TILES * 16 

  xOffset = x_screen / 2
  yOffset = y_screen / 2

VAR

  long  line_req
  long  line_buf


  long  line_1[x_tiles]       ' (1 long per x tile - pixels only)
  long  line_2[x_tiles]       ' (1 long per x tile - pixels only)
  long  line_3[x_tiles]       ' (1 long per x tile - pixels only)
  long  line_4[x_tiles]       ' (1 long per x tile - pixels only)


  long  initial_ram
  long  initial_tiles

  long  fast_screen[7]

  word  onscreen[x_tiles * y_tiles]  ' storage for screen tile map 
  word  offscreen[x_tiles * y_tiles] ' storage for screen tile map
  word  map[x_tiles * y_tiles]       ' storage for screen tile map

  long  colors[1]                   ' color look up table (16 combinations max for VGA - only 1 currently used)

  long clip
  long lastx
  long lasty 

OBJ

  vga    : "RJH_Virtual_VGA_drv_012.spin"               ' Virtual VGA driver
  gr     : "RJH_Virtual_Graphics_drv_011.spin"          ' Virtual Graphics driver
  pad    : "RJH_gamepad_drv_002"
'''  snd:  "NS_sound_drv_052_11khz_16bit"
'''  hss: "ym2413a_hss_v1"
  
DAT
                           
vgaparams               long    0               'status
                        long    1               'enable
                        long    %010_111        'pins
                        long    mode
vga_screen              long    0               'screen
vga_colors              long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    1               'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    hd
                        long    hf
                        long    hs
                        long    hb
                        long    vd
                        long    vf
                        long    vs
                        long    vb
                        long    px

CON
'           RGB0_RGB0_RGB0_RGB0
COLORS0 = %%0100_0200_0300_0000                        ' all green (good for playing)
'COLORS0 = %%3000_0030_0300_0000                          ' red blue green(good for testing)

PUB start | i

  pad.start                                             ' Start gamepad driver

  'setup vga
  long[@vga_colors] := @colors

  line_req := 0
  line_buf := 0

  fast_screen[0] := @line_req
  fast_screen[1] := @line_buf
  if DOUBLE_BUFFER
    fast_screen[2] := @onscreen
  else
    fast_screen[2] := @offscreen
  fast_screen[3] := @line_1
  fast_screen[4] := @line_2
  fast_screen[5] := @line_3
  fast_screen[6] := @line_4
  long[@vga_screen] := @fast_screen

  initial_ram := (word[$e] + _stack*4 + $003F) & $FFC0
  initial_tiles := ($8000 - initial_ram) / 64 

  'start and setup graphics
  gr.start
  gr.setup(COLOUR_MODE, X_TILES, Y_TILES, xOffset, yOffset, @offscreen, @map, initial_tiles, initial_ram)
  gr.db_setup(@onscreen, DOUBLE_BUFFER)


  vga.start(@vgaparams)

  if RAM_RECYCLE
    'now that the cogs are loaded, reclaim the RAM that was used to hold their data
    gr.addram (gr.ramstart, gr.ramend)
    gr.addram (gr.db_ramstart, gr.db_ramend)
    gr.addram (vga.ramstart, vga.ramend)
    gr.addram (vga.lg_ramstart, vga.lg_ramend)
    gr.addram (pad.ramstart, pad.ramend)

  colors[0] := COLORS0                            
    
  gr.clear

  clip := yOffset/4

  DrawRadar( 0, 0 )
  DrawCrossHairs( 0, 0 )
  if DOUBLE_BUFFER
    gr.copy(@onscreen)

  'cognew( TankTask, @stack1 )
  'cognew( BackdropTask, @stack2 )
  cognew(combinedTankAndBackdropTask,@stack1)

                                ' Initialize HYDRA-Net
  dira[RX_PIN] := 0             ' input
  dira[TX_PIN] := 1             ' output
  outa[TX_PIN] := 1

  self := TryToBeMaster

  steeringModes[0] := steeringModes[1] := 0
  
  repeat
    Game

CON     ' Object stuff (game objects are not to be confused with Spin OBJs!)

OBJTYPE_TANK = 0
OBJTYPE_CUBE = 1
OBJTYPE_HALFCUBE = 2
OBJTYPE_PYRAMID = 3
OBJTYPE_BULLET = 4

NOBJECTS = 16   ' 2 tanks, 2 bullets, the rest obstacles

SHIFT   = 8

'Perspective distortion - a little bit is quite effective, too much looks unrealistic:

'PERSPECTIVE = 512 ' low distortion
PERSPECTIVE = 384 ' mild distorted
'PERSPECTIVE = 256 ' high distorted
'
VAR

long    obj_xs[NOBJECTS]        ' world x-coordinate (24.8)
long    obj_ys[NOBJECTS]        ' world y-coordinate (24.8)
word    obj_hs[4]               ' heading (only tanks and bullets have headings)
byte    obj_types[NOBJECTS]     ' type of object
byte    obj_timers[NOBJECTS]    ' life timer:
                                '   for tanks, -1 => alive, 0 => dead, +ve => time left in flashing mode 
                                '   for bullets, 0 => inactive, non-0 => time left in flight
                                '   for objects, 0 => non-flashing, non-0 => time left in flashing mode

long    stack1[30]
'long    stack2[30]

PRI Game | i

  InitObjects
  controls[self] := constant(pad#NES_LEFT|pad#NES_UP)

  gr.clear
  
  repeat

    if not DOUBLE_BUFFER
      gr.clear

    Move
    Draw
    repeat i from CONSTANT(COLOUR_MODE*2) to 0
      gr.colorwidth(i+1, 2*(i+1))
      gr.textmode( 2, 2, CONSTANT (6 + COLOUR_MODE), %01_11 )
      gr.text( 0, 0, string("HYDRA") )
      gr.textmode( 2, 2, CONSTANT (6 + COLOUR_MODE), %01_10 )
      gr.text( 0, 0, string("BATTLEZ0WNED") )

    if self == 0
      gr.colorwidth( 3, 0 )
      gr.textmode( 1, 1, 6, %01_01 )
      gr.text( 0, -60, string("PRESS START") )
       
    if DOUBLE_BUFFER
      gr.move(@onscreen)

    gr.width( 0 )

    if self == 0   
      if pad.button( pad#NES0_START )
        repeat while pad.button( pad#NES0_START )
        Transceive( 1 )
        quit
      else
        Transceive( 0 )
    else        
      if Transceive( 0 ) == 1
        quit

  if self == 0
    rand := cnt
    Transceive( rand )
  else
    rand := Transceive( 0 )
         
  scores[0] := scores[1] := 0
  strScore[0] := strScore[2] := "0"

  rand2 := cnt
  
  repeat  

    PlayRound
    
    gr.clear
    if DOUBLE_BUFFER
      gr.copy(@onscreen)
    repeat i from CONSTANT (COLOUR_MODE*2) to 0
      gr.colorwidth(i+1, 2*(i+1))
      gr.textmode( 2, 2, 7, %01_01 )
      gr.text( 0, 0, @strScore )
    gr.width( 0 )
    if DOUBLE_BUFFER
      gr.copy(@onscreen)
    if ( scores[0] => 5 or scores[1] => 5 ) and ( scores[0] <> scores[1] )
      quit
    waitcnt( clkfreq*2 + cnt )

  gr.colorwidth( 3, 0 )
  gr.textmode( 1, 1, 6, %01_01 )
  if scores[self] > scores[self^1]
    gr.text( 0, -40, string("YOU WIN") )
  else
    gr.text( 0, -40, string("GAME OVER") )
  if DOUBLE_BUFFER
    gr.copy(@onscreen)

  waitcnt( clkfreq*4 + cnt )
   
DAT

strScore      byte      "0-0", 0
strSteeringMode byte    "A",0
  
PRI PlayRound | over
              
  InitObjects
  prevControls[0] := prevControls[1] := 0

  gr.clear

  repeat                                                            

    if not DOUBLE_BUFFER
      gr.clear

    if SOLO
      if pad.button( pad#NES_START )
        controls[self^1] := pad.read
      else
        controls[self] := pad.read
    else
      controls[self] := pad.read
      controls[self^1] := Transceive( controls[self] )
    
    Move
    Draw
    strSteeringMode := "A" + steeringModes[self]
    gr.color( 2 )
    gr.text( 60, CONSTANT (yOffset-16), @strSteeringMode )

    prevControls[0] := controls[0]
    prevControls[1] := controls[1]
      
    obj_timers[2] := obj_timers[2] - 1 #> 0
    obj_timers[3] := obj_timers[3] - 1 #> 0
    
    if DOUBLE_BUFFER
      gr.move(@onscreen)
                                                         ' The round is over when
    over := obj_timers[0] == 0 or obj_timers[1] == 0     ' Either tank is dead
    over and= ~obj_timers[0] =< 0 and ~obj_timers[1] =< 0' But not if one is in the process of dying
    over and= obj_timers[2] == 0 and obj_timers[3] == 0  ' And not if bullets are still in flight
    
  until over 

VAR

byte    self                    ' Either 0 or 1; the other machine's self is the complement of this.
byte    controls[2]
byte    prevControls[2]
byte    scores[2]
byte    steeringModes[2]

CON

FIELDSIZE = 6000

PRI InitObjects | i, i1, i2, t

  obj_xs[0] := randi( FIELDSIZE ) << SHIFT
  obj_ys[0] := randi( FIELDSIZE ) << SHIFT
  obj_hs[0] := randi( 8_192 )
  obj_hs[0] := OBJTYPE_TANK
  repeat
    obj_xs[1] := randi( FIELDSIZE ) << SHIFT
    obj_ys[1] := randi( FIELDSIZE ) << SHIFT
    obj_hs[1] := randi( 8_192 )
    obj_hs[1] := OBJTYPE_TANK
  until not TooCrowded( 1, 3_000 )
  
  obj_timers[0] := obj_timers[1] := -1     

  obj_types[2] := obj_types[3] := OBJTYPE_BULLET
  obj_timers[2] := obj_timers[3] := 0     
  
  i1 := (NOBJECTS - 4) * 1 / 3 + 4  
  i2 := (NOBJECTS - 4) * 2 / 3 + 4  

  t := OBJTYPE_CUBE
  repeat i from 4 to NOBJECTS-1
    if i == i1 or i == i2
      ++t                                               ' t steps through {OBJTYPE_CUBE, OBJTYPE_HALFCUBE, OBJTYPE_PYRAMID}.
    obj_types[i] := t
    repeat
      obj_xs[i] := randi( FIELDSIZE ) << SHIFT
      obj_ys[i] := randi( FIELDSIZE ) << SHIFT
    until not TooCrowded( i, 1000 )
    obj_timers[i] := 0

PRI TooCrowded( n, dist ) | i                           ' Returns true if object[n] is within dist of any object[i], i < n.

  repeat i from 0 to n-1
    if i == 2 or i == 3                                 ' Skip the bullets.
      next
    if ||( obj_xs[i] - obj_xs[n] ) < dist << SHIFT and ||( obj_ys[i] - obj_ys[n] ) < dist << SHIFT
      return true
      
  return false      

CON

TURNINC = 32    ' higher speed means faster turn, but less aiming accuracy
BULLETLIFE = 60
FLASHTIME = 40
ROR_SPEED = 3   ' distance per move is ror'd by this amount, so smaller values mean faster

PRI Move | i, x, y, dx, dy, o, diff, d

  backdropTaskControl := 1
  
  repeat i from 0 to 1                                  ' Turn tanks.
    if ~obj_timers[i] => 0
      next
    d := 0
    if controls[i] & pad#NES_LEFT
      d := TURNINC
    if controls[i] & pad#NES_RIGHT
      d := -TURNINC
    if steeringModes[i]
      if controls[i] & pad#NES_DOWN
        d := -d
    obj_hs[i] += d

  repeat i from 0 to 1                                  ' Move tanks.
    if ~obj_timers[i] => 0
      next
    dx := Cos( obj_hs[i] ) ~> ROR_SPEED
    dy := Sin( obj_hs[i] ) ~> ROR_SPEED     
    x := obj_xs[i] 
    y := obj_ys[i]

    diff := prevControls[i] ^ controls[i]
    if controls[i] & pad#NES_UP
      x += dx 
      y += dy  
    if controls[i] & pad#NES_DOWN
      x -= dx 
      y -= dy  
    if controls[i] & constant(pad#NES_A | pad#NES_B) & diff
      if (obj_timers[i+2] == 0) and (~obj_timers[i^1] == -1) ' Bullet not already in flight and other tank is still alive.
        obj_xs[i+2] := obj_xs[i]
        obj_ys[i+2] := obj_ys[i]
        obj_hs[i+2] := obj_hs[i]
        obj_timers[i+2] := BULLETLIFE
    if controls[i] & pad#NES_SELECT & diff
      steeringModes[i] ^= 1
       
    if Blocked( x, y, i )
      if i == self
        repeat until tankTaskControl == 0 and backdropTaskControl == 0
        gr.textmode( 1, 1, 6, 0 )
        gr.color(1)
        gr.text( CONSTANT (8-xOffset), CONSTANT (yOffset-16), string("BLOCKED") )
    else
      obj_xs[i] := x
      obj_ys[i] := y

  repeat i from 2 to 3                                  ' Move bullets.
    if obj_timers[i] == 0
      next
    dx := Cos( obj_hs[i] ) ~> 5
    dy := Sin( obj_hs[i] ) ~> 5
    repeat 10
      obj_xs[i] += dx
      obj_ys[i] += dy
      if (o := Hit(i)) => 0                             ' Bullet hit something?
        if o < 2                                        ' Was it a tank?
          if ~obj_timers[o] < 0                         ' Only the first hit on the tank counts.
            obj_timers[i] := 0                          ' Turn off bullet.
            obj_timers[o] := FLASHTIME                  ' Make tank flash.
            ++scores[1^o]                               ' Keep score.
            strScore[(1^o^self)<<1] := "0" + scores[1^o]//10 ' Update score display

        else                                            ' All other objects:
          obj_timers[i] := 0                            ' Turn off bullet.
          obj_timers[o] := FLASHTIME                    ' Make object flash.
        quit       

PRI Blocked( x, y, o ) | i, r

  repeat i from 0 to CONSTANT(NOBJECTS-1)
    if i < 2
      r := CONSTANT(300 << SHIFT)
    else
      r := CONSTANT(150 << SHIFT)
      
    if i == o or i == 2 or i == 3
      next
    if ||( obj_xs[i] - x ) > r
      next
    if ||( obj_ys[i] - y ) > r
      next
    return true

  return false           

PRI Hit( b ) | i, r, x, y
                   
  x := obj_xs[b]
  y := obj_ys[b]

  repeat i from 0 to CONSTANT(NOBJECTS-1)
    if i == b-2
      next
      
    if obj_types[i] == OBJTYPE_TANK
      r := CONSTANT(35 << SHIFT)
    elseif obj_types[i] == OBJTYPE_BULLET or obj_types[i] == OBJTYPE_HALFCUBE 
      next
    elseif obj_types[i] == OBJTYPE_PYRAMID
      r := CONSTANT(25 << SHIFT)
    else
      r := CONSTANT(50 << SHIFT)
      
    if ||( obj_xs[i] - x ) > r
      next
    if ||( obj_ys[i] - y ) > r
      next
    return i

  return -1           

CON     ' Tank wireframe data

TANK_NPOINTS = 22
TANK_NLINES = 37

DAT
tank_xs       byte   100,  100, -100, -100,  115, 115, -115, -115,   50,   50,  -90,  -90, -60, -60,  90,  90,   0,   0,  90,  90, -25, -25 
tank_ys       byte   -50,   50,   50,  -50,  -65,  65,   65,  -65,  -30,   30,   30,  -30, -15,  15,  -5,   5,   5,  -5,  -5,   5,   5,  -5  
tank_zs       byte     0,    0,    0,    0,   20,  20,   20,   20,   40,   40,   40,   40,  75,  75,  55,  55,  55,  55,  65,  65,  65,  65 

tank_i0s      byte  12, 12, 12, 13, 13, 14, 15, 16, 17, 17, 8,  9, 10, 11,  8,  9, 10, 11,  4,  5,  6,  7,  1,  2,  3,  18, 19, 20, 21, 14, 15, 16, 0,  3,  0,  1,  2  
tank_i1s      byte  13,  8, 11,  9, 10, 15, 16, 17, 14, 21, 9, 10, 11,  8,  4,  5,  6,  7,  5,  6,  7,  4,  5,  6,  7,  19, 20, 21, 18, 18, 19, 20, 1,  0,  4,  2,  3  

VAR
word tank_rxs[TANK_NPOINTS]
word tank_rys[TANK_NPOINTS]

CON     ' Obstacle wireframe data

OBST_NPOINTS = 13

CUBE_NLINES = 12
HALFCUBE_NLINES = 12
PYRAMID_NLINES = 8

DAT
obst_xs       byte    50,   50,  -50,  -50,   50,   50,  -50,  -50,   50,   50,  -50,  -50,    0
obst_ys       byte   -50,   50,   50,  -50,  -50,   50,   50,  -50,  -50,   50,   50,  -50,    0
obst_zs       byte     0,    0,    0,    0,   55,   55,   55,   55,  120,  120,  120,  120,  120

cube_i0s      byte  0,  1,  2,  3,  8,  9, 10, 11,  0,  1,  2,  3
cube_i1s      byte  1,  2,  3,  0,  9, 10, 11,  8,  8,  9, 10, 11

halfcube_i0s  byte  0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3
halfcube_i1s  byte  1,  2,  3,  0,  5,  6,  7,  4,  4,  5,  6,  7

pyramid_i0s   byte  0,  1,  2,  3,  0,  1,  2,  3
pyramid_i1s   byte  1,  2,  3,  0, 12, 12, 12, 12

VAR
word    obst_rxs[OBST_NPOINTS]
word    obst_rys[OBST_NPOINTS]

long    xs[NOBJECTS]
long    ys[NOBJECTS]

'As we are only using one cog to draw, we only need one set of temps - just make sure TANK_NPOINTS is > OBST_NPOINTS!!!
long    xtemps[TANK_NPOINTS]
long    ytemps[TANK_NPOINTS]
long    ztemps[TANK_NPOINTS]


CON     ' Bullet wireframe data

BULLET_NPOINTS  = 5
BULLET_NLINES   = 8

DAT

bullet_xs     byte      -10, -10, -10, -10, 10
bullet_ys     byte        5,   5,  -5,  -5, 0
bullet_zs     byte       55,  65,  65,  55, 60

bullet_i0s    byte      0, 1, 2, 3, 4, 4, 4, 4
bullet_i1s    byte      1, 2, 3, 0, 0, 1, 2, 3

VAR
word    bullet_rxs[BULLET_NPOINTS]
word    bullet_rys[BULLET_NPOINTS]

CON
EYEHEIGHT       = 66

VAR
byte    tankTaskControl
byte    backdropTaskControl

PRI Draw | b

  DrawObjects
     
  DrawRadar( xs[self^1], ys[self^1] )
  DrawCrosshairs( xs[self^1], ys[self^1] )

  gr.textmode( 1, 1, 6, %10_00 )
  gr.color( 1 )
  gr.text( CONSTANT(xOffset - 16), CONSTANT(yOffset - 16), @strScore )
  
  if ~obj_timers[self] > 0
    b := Randii(6) + 1
    colors[0] := CONSTANT(COLORS0 & $fffffff8) + b
    --obj_timers[self]
    if ~obj_timers[self] == 0
      colors[0] := COLORS0

  repeat until tankTaskControl == 0 and backdropTaskControl == 0
   
VAR
long    angle

PRI DrawObjects | x0, y0, x, y, i, s, c   

  x0 := obj_xs[self]
  y0 := obj_ys[self]
   
  angle := 2048 - obj_hs[self]                          ' We want to rotate the world around self so that self points north (2048)
  s := sin( angle ) ~> 8
  c := cos( angle ) ~> 8
   
  repeat i from 0 to CONSTANT (NOBJECTS-1)
    x := obj_xs[i] - x0
    y := obj_ys[i] - y0
    xs[i] := (c*x - s*y) ~> CONSTANT (8 + SHIFT)
    ys[i] := (s*x + c*y) ~> CONSTANT (8 + SHIFT)
                                                        ' Wait until backdrop and tank finish drawing. Wasting valuable time here,
                                                        ' but this prevents the background-on-foreground drawing error.
                                                        ' Plus, since the backdrop task had a head start, it shouldn't
                                                        ' be too long a wait. I hope. Probably should do some actual timing...  

  repeat until backdropTaskControl == 0 and tankTaskControl == 0

  RotateObstacle( angle )
  repeat i from 4 to CONSTANT (NOBJECTS-1)
    DrawObstacle( i )
   
  repeat i from 2 to 3
    RotateBullet( angle + obj_hs[i] )
    DrawBullet( i )

  tankTaskControl := 1
   
PRI DrawShape(i0s, i1s, n) | i, i0, i1, lasti1
  lasti1 := -1
  repeat i from 0 to n                                  ' Draw.
    i0 := byte[i0s][i]
    i1 := byte[i1s][i]
    if i0 <> lasti1
      'gr.plot( xtemps[i0], ytemps[i0] )
      ClipPlot( xtemps[i0], ytemps[i0] )
    'gr.line( xtemps[i1], ytemps[i1] )
    ClipLine( xtemps[i1], ytemps[i1] )
    lasti1 := i1

PRI Perspectivize (t, rxs, rys, zs, NPOINTS) | w, i

  repeat i from 0 to NPOINTS                            ' Translate local rotated coords to self-centered coords.
    xtemps[i] := ~~word[rxs][i] + xs[t]
    ytemps[i] := ~~word[rys][i] + ys[t]
    ztemps[i] := byte[zs][i] - EYEHEIGHT                   
    w := ytemps[i]                                      ' Perspectivize
    xtemps[i] := xtemps[i] * PERSPECTIVE / w
    ytemps[i] := ztemps[i] * PERSPECTIVE / w
                                                        

PRI DrawTank( t ) | i, i0, i1

  if ys[t] =< 0 or ||xs[t]/CLIP_ADJUST > ys[t]                    ' Cheap clipping.
    return

  if obj_timers[t] == 0
    return
   
  if ~obj_timers[t] < 0
    gr.color( 1 )     ' was 2
  else
    gr.color( Randii(4) )
    if --obj_timers[t] == 0
      return

  Perspectivize(t, @tank_rxs, @tank_rys, @tank_zs, CONSTANT(TANK_NPOINTS-1))
  
  'gr.width(CONSTANT(1 - COLOUR_MODE))                   'draw objects with thicker lines when using 2 color mode

  DrawShape(@tank_i0s, @tank_i1s, CONSTANT(TANK_NLINES-1))    

  'gr.width(0)

PRI DrawObstacle( o ) | c

  if ys[o] =< 0 or ||xs[o]/CLIP_ADJUST > ys[o]                    ' Cheap clipping.    
    return

  if obj_timers[o] == 0
    gr.color( 2 )
  else
    c := Randii(4)
    gr.color( c )
    --obj_timers[o]

  'gr.width(CONSTANT(1 - COLOUR_MODE))                   'draw objects with thicker lines when using 2 color mode
     
  Perspectivize(o, @obst_rxs, @obst_rys, @obst_zs, 13)
  case obj_types[o]
    OBJTYPE_CUBE:
      DrawShape(@cube_i0s, @cube_i1s, CONSTANT(CUBE_NLINES-1))    
    OBJTYPE_HALFCUBE:
      DrawShape(@halfcube_i0s, @halfcube_i1s, CONSTANT(HALFCUBE_NLINES-1))    
    OBJTYPE_PYRAMID:
      DrawShape(@pyramid_i0s, @pyramid_i1s, CONSTANT(PYRAMID_NLINES-1))    

  'gr.width(0)

PRI DrawBullet( b )

  if obj_timers[b] == 0
    return

  if ys[b] =< 0 or ||xs[b] > ||ys[b]                    ' Cheap clipping.
    return

  gr.color( 1 )
      
  Perspectivize(b, @bullet_rxs, @bullet_rys, @bullet_zs, CONSTANT(BULLET_NPOINTS-1))

  DrawShape(@bullet_i0s, @bullet_i1s, CONSTANT(BULLET_NLINES-1))    
        
PRI RotateTank( theta ) | i, s, c

  s := sin( theta ) ~> 8
  c := cos( theta ) ~> 8
  
  repeat i from 0 to CONSTANT(TANK_NPOINTS-1)
    tank_rxs[i] := (c*~tank_xs[i] - s*~tank_ys[i]) ~> 8
    tank_rys[i] := (s*~tank_xs[i] + c*~tank_ys[i]) ~> 8
  
PRI RotateObstacle( theta ) | i, s, c

  s := sin( theta ) ~> 8
  c := cos( theta ) ~> 8
  
  repeat i from 0 to 3
    obst_rxs[i] := (c*~obst_xs[i] - s*~obst_ys[i]) ~> 8
    obst_rys[i] := (s*~obst_xs[i] + c*~obst_ys[i]) ~> 8

  repeat i from 4 to 11
    obst_rxs[i] := obst_rxs[i-4]
    obst_rys[i] := obst_rys[i-4]
  
PRI RotateBullet( theta ) | i, s, c

  s := sin( theta ) ~> 8
  c := cos( theta ) ~> 8
  
  repeat i from 0 to CONSTANT(BULLET_NPOINTS-1)
    bullet_rxs[i] := (c*~bullet_xs[i] - s*~bullet_ys[i]) ~> 8
    bullet_rys[i] := (s*~bullet_xs[i] + c*~bullet_ys[i]) ~> 8
  
PRI DrawCrosshairs( x, y ) | u

  if y > 0 and ||x < (||y>>4 #> 50)    
    gr.color( 1 )
    u := 12
  else
    gr.color( 2 )
    u := 20
    
  gr.plot( 0, 40 )
  gr.line( 0, 20 )
  gr.plot( 0, -40 )
  gr.line( 0, -20 )
  gr.plot( -20, 20 )
  gr.line( 20, 20 )
  gr.plot( -20, -20 )
  gr.line( 20, -20 )
  gr.plot( -20, 20 )
  gr.line( -u, 12 )
  gr.plot( 20, 20 )
  gr.line( u, 12 ) 
  gr.plot( -20, -20 )
  gr.line( -u, -12 )
  gr.plot( 20, -20 )
  gr.line( u, -12 )

PRI DrawRadar( x, y )

  gr.color( 2 )
  gr.plot( 0,   CONSTANT(yOffset-1) )
  gr.line( 0,   CONSTANT(yOffset-3) )
  gr.plot( 15,  CONSTANT(yOffset-16) )
  gr.line( 13,  CONSTANT(yOffset-16) )
  gr.plot( 0,   CONSTANT(yOffset-32) )
  gr.line( 0,   CONSTANT(yOffset-30) )
  gr.plot( -15, CONSTANT(yOffset-16) )
  gr.line( -13, CONSTANT(yOffset-16) )
         
  gr.color( 3 )
  gr.plot( 9,   CONSTANT(yOffset-5) )
  gr.line( 0,   CONSTANT(yOffset-17) )
  gr.plot( 0,  CONSTANT(yOffset-17) )
  gr.line( -9,  CONSTANT(yOffset-5) )
  x ~>= 9
  if x < -13 or x > 13
    return
  y ~>= 9
  if y < -13 or y > 13
    return
  gr.color( 1 )
  gr.plot( x, y + CONSTANT(yOffset-16) )


'
' Not enough cogs to have separate cogs for tank and backdrop drawing, so we combine them and use one cog for both
'
{
PRI BackdropTask

  repeat
    repeat until backdropTaskControl

    DrawBackdrop( obj_hs[self] )
    
    backdropTaskControl~

}    
{
PRI TankTask

  repeat
    repeat until tankTaskControl
    
    RotateTank( angle + obj_hs[ self^1 ] )
    DrawTank( self^1 )

    tankTaskControl~
}    
PRI CombinedTankAndBackdropTask
  repeat
    repeat until (tankTaskControl == 1) or (backdropTaskControl == 1)

    if tankTaskControl
    
      RotateTank( angle + obj_hs[ self^1 ] )
      DrawTank( self^1 )


      tankTaskControl~
      
    if backdropTaskControl
  
      DrawBackdrop( obj_hs[self] )
    
      backdropTaskControl~
      
    

PRI DrawBackdrop( theta ) | p, x, y, offset, xprevOnscreen, xOnscreen, i, n
                                  
  n := CONSTANT (((@bkgd_end - @bkgd_pts) / 2) - 1)

  offset := ( -theta & 8191 ) / 5  + xOffset 
  
  gr.color( 3 )
  gr.plot( -xOffset, 0 )
  gr.line( xOffset, 0 )

  p := @bkgd_pts
  repeat i from 0 to  n
    x := byte[p++]<<5/5 - offset
    xOnscreen := ||x < xOffset
    y := byte[p++]
    if ~y < 0
      gr.plot( x, -~y )
    else
      if xOnscreen or xprevOnscreen
        gr.line( x, y )
      else        
        gr.plot( x, y )
    if xPrevOnscreen and x > xOffset + 50
       quit
    xprevOnscreen := xOnscreen

  p := @bkgd_pts
  if not (xPrevOnscreen and x > CONSTANT(xOffset + 50))
    repeat i from 0 to  n
      x := (256 + byte[p++])<<5/5 - offset
      xOnscreen := ||x < xOffset
      y := byte[p++]
      if ~y < 0
        gr.plot( x, -~y )
      else
        if xOnscreen or xprevOnscreen
          gr.line( x, y )
        else        
          gr.plot( x, y )
      if xPrevOnscreen and x > CONSTANT(xOffset + 50)
         quit
      xprevOnscreen := xOnscreen
      

  gr.color(1)
  repeat i from 0 to 2
    plume_dys[i]--
    plume_ys[i] += plume_dys[i]
    plume_xs[i] += plume_dxs[i]
    if ~plume_ys[i] < -50-Randi(50)
      plume_xs[i] := plume_ys[i] := 0
      plume_dxs[i] := Randi(7)-3
      plume_dys[i] := Randi(8)+9
    gr.plot( 1275+(~plume_xs[i]~>3)-offset, 12+(~plume_ys[i]~>4) )

DAT
bkgd_pts
        byte      0,-1
        byte      4,25
        byte      10,1
        byte      13,7
        byte      15,15
        byte      18,0
        byte      27,-1
        byte      34,12
        byte      40,0

        byte      39,-4
        byte      43,18
        byte      46,9
        byte      49,7
        byte      43,-18
        byte      54,0

        byte      56,-1
        byte      60,9
        byte      59,-1
        byte      60,9
        byte      63,0

        byte      70,-1
        byte      75,8
        byte      80,4
        byte      80,-1
        byte      82,14
        byte      84,17
        byte      88,0

        byte      93,-1
        byte      94,12
        byte      95,9
        byte      96,0

        byte      106,-1
        byte      112,6
        byte      114,16
        byte      114,16
        byte      117,8
        byte      121,0
        byte      119,-5
        byte      122,10
        byte      124,4
        byte      123,-1
        byte      127,12
        byte      131,0

        byte      140,-1
        byte      143,15
        byte      148,0
        byte      143,-15
        byte      153,0
        byte      157,18
        byte      158,7
        byte      161,23
        byte      164,0
        byte      158,-7
        byte      161,0

        byte      171,-1
        byte      175,13
        byte      177,6
        byte      178,11
        byte      182,5
        byte      181,-1
        byte      183,8
        byte      187,8
        byte      193,0

        byte      196,-1
        byte      199,12
        byte      202,0

        byte      206,-1
        byte      209,5
        byte      208,-1
        byte      210,12
        byte      214,4
        byte      213,-1
        byte      216,18
        byte      218,15
        byte      222,0

        byte      229,-1
        byte      232,15
        byte      235,7
        byte      234,-1
        byte      236,14
        byte      238,18
        byte      240,0
        byte      240,-4
        byte      242,8
        byte      243,4
        byte      250,0
bkgd_end

                            

plume_xs      byte      0, 0, 0
plume_ys      byte      0, 0, 0
plume_dxs     byte     -3, 1, 2
plume_dys     byte     10, 7, 15
    
VAR
  long rand

PRI Randi(n)
  return (?rand & $7fffffff) // n

' Use Randi for random #s common to both machines.
' Use Randii for random #s that don't have to be synchronized (e.g. for flashing effects)

VAR
  long rand2

PRI Randii(n)
  return (?rand2 & $7fffffff) // n

{
PRI DistanceSquared( x0, y0, x1, y1 ) | dx, dy
  dx := x1 - x0
  dy := y1 - y0
  return dx*dx + dy*dy
  
PRI Distance( x0, y0, x1, y1 )
  return ^^DistanceSquared( x0, y0, x1, y1 )
}
PRI Sin( a ) ' [0..8191] -> 16-bit result
  a &= $1fff
  if a < 2048
    return word[$e000][a] 'sinlookup(a)
  elseif a < 4096
    return word[$e000][4096-a] 'sinlookup(4096-a)
  elseif a < CONSTANT(2048+4096)
    return -word[$e000][a-4096] '-sinlookup(a-4096)
  else
    return -word[$e000][8192-a] '-sinlookup(8192-a)

'PRI sinlookup( a ) | s
'  return word[$e000][a]

PRI Cos( a )
  return Sin( a + 2048 )

CON     ' HYDRA-Net stuff

TX_PIN  = 2
RX_PIN  = 1
DELAY   = 1

PRI TryToBeMaster               ' Return 0 if master, 1 if slave.
  if SOLO
    return 0
  outa[TX_PIN] := 0
  repeat 100'DELAY
  if ina[RX_PIN] == 0
    outa[TX_PIN] := 1
    repeat 100'DELAY
    if ina[RX_PIN] == 1
      return 0

  repeat until ina[RX_PIN] == 0 ' OK, this isn't really reliable
  outa[TX_PIN] := 0
  repeat until ina[RX_PIN] == 1
  outa[TX_PIN] := 1

  return 1

PRI Transceive( outgoing ) | incoming
  if SOLO
    return 0
  if self == 0
    outa[TX_PIN] := 0
    repeat until ina[RX_PIN] == 0
  else
    repeat until ina[RX_PIN] == 0
    outa[TX_PIN] := 0

  repeat 32
    outa[TX_PIN] := outgoing & 1
    outgoing >>= 1
    repeat DELAY
    incoming >>= 1
    incoming |= ina[RX_PIN] << 31
    repeat DELAY
  outa[TX_PIN] := 1
  return incoming

pri ClipPlot (x, y)
  if ||y < clip
    gr.plot(x, y)

  lastx := x
  lasty := y
 

pri ClipLine (x, y) | dx, dy
  dy := ||(y - lasty)
  dx := x - lastx
  if ||lasty < clip
    if ||y < clip
      'draw whole line
     gr.line(x, y)
    else
      'draw part of line
      if y > 0
        gr.line(lastx+(dx*(clip-lasty))/dy, clip)
      else
        gr.line(lastx+(dx*(clip+lasty))/dy, -clip)
  else
    if ||y < clip
      'draw part of line
      if lasty > 0 
        gr.plot(x-((dx*(clip-y))/dy),clip)
      else
        gr.plot(x-((dx*(clip+y))/dy),-clip)
      gr.line(x, y)
    elseif (lasty =< -clip) and (y => clip)
      gr.plot(x-((dx*(clip+y))/dy),-clip)
      gr.line(lastx+(dx*(clip-lasty))/dy, clip)
    elseif (lasty => clip) and (y =< -clip)
      gr.plot(x-((dx*(clip-y))/dy),clip)
      gr.line(lastx+(dx*(clip+lasty))/dy, -clip)
    
  lastx := x
  lasty := y
                    